// asset.cpp
//
// Copyright (C) 2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include "asset.hpp"
#include <openassetlib/al/al.hpp>

namespace olib { namespace openassetlib { namespace al {

	asset::asset()
		: dirty_(true)
	{
		guid_ = generate_guid();
	}

	asset::asset(const opl::string& guid)
		: guid_(guid)
		, dirty_(true)
	{
	}

	asset::asset(const asset_ptr& asset)
		: dirty_(true)
	{
		if(asset == asset_ptr())
			return;

		guid_ = generate_guid();

		// copy all metadata
		if(!asset->empty())
		{
			const_iterator cit = asset->begin();
			do
			{
				map_.insert(value_type(cit->first, cit->second));

			}	while(++cit != asset->end());
		}
	}

} } }
