
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openeffectslib/fx/n_operator_at.hpp>

namespace olib { namespace openeffectslib { namespace fx {

n_operator_at::n_operator_at( )
	: n_operator( empty_fields( ), empty_params( ) )
{ }

n_operator_at::n_operator_at( const container& fields, const param_container& params )
	: n_operator( fields, params )
{ }

n_operator_at::~n_operator_at( )
{ }

bool n_operator_at::init( )
{
	return ( op_image( ) && op_image( )->init( ) ) && ( op_audio( ) && op_audio( )->init( ) );
}

bool n_operator_at::update_image( )
{
	return op_image( ) ? op_image( )->update_image( ) : false;
}

bool n_operator_at::update_audio( )
{
	return op_audio( ) ? op_audio( )->update_audio( ) : false;
}

bool n_operator_at::dirty( ) const
{
	return ( op_image( ) && op_image( )->dirty( ) ) || ( op_audio( ) && op_audio( )->dirty( ) );
}

const fx::audio_buffer n_operator_at::ab( ) const
{
	return op_audio( ) ? op_audio( )->ab( ) : fx::audio_buffer( );
}

void n_operator_at::bind_as_GL_texture( ) const
{
	if ( op_image( ) )
		op_image( )->bind_as_GL_texture( );
}

void n_operator_at::unbind_as_GL_texture( ) const
{
	if ( op_image( ) )
		op_image( )->unbind_as_GL_texture( );
}

GLuint n_operator_at::get_GL_texture( ) const
{
	return op_image( ) ? op_image( )->get_GL_texture( ) : 0;
}

GLenum n_operator_at::get_GL_target( ) const
{
	return op_image( ) ? op_image( )->get_GL_target( ) : 0;
}

int n_operator_at::width( ) const
{
	return op_image( ) ? op_image( )->width( ) : 0;
}

int n_operator_at::height( ) const
{
	return op_image( ) ? op_image( )->height( ) : 0;
}

float n_operator_at::max_s( ) const
{
	return op_image( ) ? op_image( )->max_s( ) : 0;
}

float n_operator_at::max_t( ) const
{
	return op_image( ) ? op_image( )->max_t( ) : 0;
}

} } }
