
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openeffectslib/fx/n_operator_gpu.hpp>

namespace olib { namespace openeffectslib { namespace fx {

n_operator_gpu::n_operator_gpu( const container& fields, const param_container& params )
	: n_operator( fields, params )
{ }

n_operator_gpu::n_operator_gpu( const creator_t creator )
	: n_operator( creator.first, creator.second )
{ }

n_operator_gpu::n_operator_gpu( const n_operator_gpu& other )
	: n_operator( other )
	, rb_( other.rb_ )
{ }

n_operator_gpu& n_operator_gpu::operator=( const n_operator_gpu& other )
{
	n_operator_gpu( other ).swap( *this );
	return *this;
}

void n_operator_gpu::swap( n_operator_gpu& other )
{ rb_.swap( other.rb_ ); }
	
n_operator_gpu::~n_operator_gpu( )
{ }

bool n_operator_gpu::set_size( int new_w, int new_h )
{
	if( !rb_.initialised( ) || new_w != width( ) || new_h != height( ) )
		return rb_.init( "", new_w, new_h );
		
	return rb_.initialised( );
}

} } }
