
// fx - A compositing library representation.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#ifndef MEDIA_CLIP_OPERATOR_INC_
#define MEDIA_CLIP_OPERATOR_INC_

#if _MSC_VER
#pragma warning ( push )
#	pragma warning ( disable:4275 )
#endif

#include <GL/glew.h>

#include <openmedialib/ml/ml.hpp>

#include <openeffectslib/plugins/openmedialib_source/config.hpp>

#include <openeffectslib/fx/n_operator_at.hpp>
#include <openeffectslib/fx/clip.hpp>

namespace olib { namespace openeffectslib { namespace plugins {

//
class OPENMEDIALIB_SOURCE_DECLSPEC media_clip_operator : public fx::n_operator_at, public fx::clip
{
public:
	explicit media_clip_operator( );

	virtual bool init( );

	virtual bool set_playable( fx::n_operator_ptr );
	virtual int in( ) const;
	virtual int out( ) const;
	virtual void set_in( int );
	virtual void set_out( int );
	virtual int source_length( ) const;

	virtual int length( ) const;
	virtual double fps( ) const;
	virtual int position( ) const;
	virtual int position_image( ) const;
	virtual int position_audio( ) const;
	virtual void seek( int position, bool relative = false );
	virtual void seek_image( int position, bool relative = false );
	virtual void seek_audio( int position, bool relative = false );

protected:
	virtual fx::n_operator_ptr op_image( ) const;
	virtual fx::n_operator_ptr op_audio( ) const;

	void clamp_points( );
	int clamp_position( int position );

private:
	fx::n_operator_ptr op_;
	fx::playable *playable_;
	fx::v_frame_position *in_;
	fx::v_frame_position *out_;
};

} } }

#if _MSC_VER
#	pragma warning ( default:4275 )
#pragma warning ( pop )
#endif

#endif

