
// openpluginlib - A plugin interface to openlibraries.

// Copyright (C) 2005-2006 Visual Media FX Ltd.
// Released under the LGPL.
// For more information, see http://www.openlibraries.org.

#include <openpluginlib/pl/property.hpp>
#include <openpluginlib/py/python.hpp>
#include <openpluginlib/py/py.hpp>

namespace opl	= olib::openpluginlib;
namespace py	= boost::python;

namespace olib { namespace openpluginlib { namespace detail {

void py_single_property( )
{
#define DEFINE_OPL_SINGLE_PROPERTY( type, name )								\
	py::class_<opl::type>( name )												\
		.add_property( "rovalue", &opl::type::value )							\
		.add_property( "value",   &opl::type::value, &opl::type::set_value )	\
		;

	DEFINE_OPL_SINGLE_PROPERTY( v_bool, "v_bool" )
	DEFINE_OPL_SINGLE_PROPERTY( v_color, "v_color" )
	DEFINE_OPL_SINGLE_PROPERTY( v_double, "v_double" )
	DEFINE_OPL_SINGLE_PROPERTY( v_float, "v_float" )
	DEFINE_OPL_SINGLE_PROPERTY( v_int32, "v_int32" )
	DEFINE_OPL_SINGLE_PROPERTY( v_matrix4d, "v_matrix4d" )
	DEFINE_OPL_SINGLE_PROPERTY( v_matrix4f, "v_matrix4f" )
	DEFINE_OPL_SINGLE_PROPERTY( v_rotation, "v_rotation" )
	DEFINE_OPL_SINGLE_PROPERTY( v_string, "v_string" )
	DEFINE_OPL_SINGLE_PROPERTY( v_uint32, "v_uint32" )
#if defined ( HAVE_BOOST_FILESYSTEM )
	DEFINE_OPL_SINGLE_PROPERTY( v_url, "v_url" )
#endif
	DEFINE_OPL_SINGLE_PROPERTY( v_vec2d, "v_vec2d" )
	DEFINE_OPL_SINGLE_PROPERTY( v_vec2f, "v_vec2f" )
	DEFINE_OPL_SINGLE_PROPERTY( v_vec3d, "v_vec3d" )
	DEFINE_OPL_SINGLE_PROPERTY( v_vec3f, "v_vec3f" )
	DEFINE_OPL_SINGLE_PROPERTY( v_vec4d, "v_vec4d" )
	DEFINE_OPL_SINGLE_PROPERTY( v_vec4f, "v_vec4f" )

#undef DEFINE_OPL_MULTI_PROPERTY
}

} } }
